package com.example;

import org.openqa.selenium.By;
import org.openqa.selenium.StaleElementReferenceException;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import static org.junit.jupiter.api.Assertions.assertEquals;

import java.util.concurrent.TimeUnit;


public class AccountSettingsPage {
    WebDriver driver;

    public AccountSettingsPage(WebDriver driver) {
        this.driver = driver;
        driver.manage().timeouts().implicitlyWait(5, TimeUnit.SECONDS);
    }

    public WebElement getAccountModal() {
        return driver.findElement(By.xpath("/html/body/div[1]/div/div/div[1]/div/div/div/div[3]/div[2]/div[1]/div/div/div[3]/ul/li[1]/a/span[1]"));
    }

    public WebElement getAccountSettingsPage() {
        return driver.findElement(By.xpath("//*[@id=\"menu\"]/div[1]/ul/li[4]/a"));
    }

    public WebElement getFirstNameField() {
        return driver.findElement(By.xpath("//*[@id=\"input-firstName\"]"));
    }

    public WebElement getLastNameField() {
        return driver.findElement(By.xpath("//*[@id=\"input-lastName\"]"));
    }

    public WebElement getEmailField() {
        return driver.findElement(By.xpath("//*[@id=\"emailIdaccount\"]"));
    }

    public void validateAccountInfo() {
        validateFirstNameField();
        validateLastNameField();
        validateEmailField();
    }

    public void validateFirstNameField() {
        WebElement firstname = getFirstNameField();
        assertEquals("Nisum", firstname.getAttribute("value"), "Values Dont Match");
    }

    public void validateLastNameField() {
        WebElement lastname = getLastNameField();
        assertEquals("TestAcct", lastname.getAttribute("value"), "Values Dont Match");
    }

    public void validateEmailField() {
        WebElement email = getEmailField();
        assertEquals("vkrijegccvsknuvnpv@miucce.com", email.getAttribute("value"), "Values Dont Match");
    }

    public void navigateToAccountSettingsPage() {
        try {
            getAccountModal().click();
            getAccountSettingsPage().click();
        } catch (StaleElementReferenceException e) {
            WebDriverWait wdw = new WebDriverWait(driver, 5);
            wdw.until(ExpectedConditions.elementToBeClickable(getAccountModal()));
            getAccountModal().click();
            getAccountSettingsPage().click();
        }

    }
}
