package com.example;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;

import java.util.concurrent.TimeUnit;

public class Login {
    WebDriver driver;


    public Login(WebDriver driver) {
        this.driver = driver;
        driver.manage().timeouts().implicitlyWait(5, TimeUnit.SECONDS);
    }


    public WebElement getUsernameInput() {
        return driver.findElement(By.id("label-email"));
    }

    public WebElement getPasswordInput() {
        return driver.findElement(By.id(("label-password")));
    }

    public WebElement getSubmitButton() {
        return driver.findElement(By.id("btnSignIn"));
    }

    public void login(String username, String password) {
        getUsernameInput().sendKeys(username);
        getPasswordInput().sendKeys(password);
        getSubmitButton().click();
    }
}
